/*

    Zelda Oni Link Begins

    Copyright (C) 2006-2008  Vincent Jouillat

    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>

#include "Texte.h"
#include "Menu.h"
#include "Joueur.h"
#include "Monde.h"
#include "Projectile.h"
#include "Jeu.h"

Texte::Texte(Jeu* jeu) : gpJeu(jeu), vitesse(40), av(0), x(0), y(0), w(0), h(0),
id(0), idsuiv(0), def(false), cadre(false), texte(""), buffer("") {
    lastAnimTime = SDL_GetTicks();
    imageFont = IMG_Load("data/images/texte/font.png");
    SDL_SetColorKey(imageFont,SDL_SRCCOLORKEY,SDL_MapRGB(imageFont->format,0,0,255));
    imageCoeur = IMG_Load("data/images/menu/coeur.png");
    SDL_SetColorKey(imageCoeur,SDL_SRCCOLORKEY,SDL_MapRGB(imageCoeur->format,0,0,255));
}

Texte::~Texte() {
    SDL_FreeSurface(imageFont);
    SDL_FreeSurface(imageCoeur);
}

void Texte::chercheText() {
    ostringstream os;
    int tmp;
    switch (id) {
        case 3  : 
            tmp = 4-(gpJeu->getJoueur()->nbQuarts()%4);
            os << tmp;
            texte = "Tu as trouv un quart de coeur !!!";
            if (tmp<4) buffer = "Encore "+os.str()+" et tu gagneras un coeur supplmentaire !!!";
            else buffer = "Ton nombre de coeurs vient d'augmenter !!!";
            break;
        case 5 : texte = "Grotte du portail scell.**Entre interdite."; break;
        case 6 : texte = "Temple de Firone**Sauvez les arbres, mangez du castor!"; break;
        case 7 : texte = "Tu as trouv les bottes de Pgases !!! *Maintiens Shift ou verrouille les majuscules pour courir."; break;
        case 8 : texte = "N : Plaine Est"; break;
        case 9 : texte = "O : Lac de Lanelle"; break;
        case 10 : texte = "S : Fort interdite"; break;
        case 11 : texte = "S : Lac de Lanelle"; break;
        case 12 : texte = "N : Vers le Temple Latouane"; break;
        case 13 : texte = "N : Village de Ruto"; break;
        case 14 : texte = "-Service Anti Monstres Urluberlus et Sauvages- (S.A.M.U.S.)**Entrez si vous n'aimez pas les monstres."; break;
        case 15 : texte = "O : Ville de Rauru"; break;
        case 16 : texte = "Vous n'avez appris aucun thme.";
            if (gpJeu->getJoueur()->hasMelodie(0)) {id=17; chercheText();break;}
            if (gpJeu->getJoueur()->hasMelodie(1)) {id=26; chercheText();break;}
            if (gpJeu->getJoueur()->hasMelodie(2)) {id=28; chercheText();break;}
            break;
        case 17 : texte = "- CHANT DE L'ENVOL*- Ne rien jouer";
            if (gpJeu->getJoueur()->hasMelodie(1)) {id=19; chercheText();break;}
            if (gpJeu->getJoueur()->hasMelodie(2)) {id=30; chercheText();break;}
            break;
        case 18 : texte = "- Chant de l'envol*- NE RIEN JOUER"; break;
        case 19 : texte = "- CHANT DE L'ENVOL*- Hymne du vide*- Ne rien jouer";
            if (gpJeu->getJoueur()->hasMelodie(2)) {id=22; chercheText();break;}
            break;
        case 20 : texte = "- Chant de l'envol*- HYMNE DU VIDE*- Ne rien jouer"; break;
        case 21 : texte = "- Chant de l'envol*- Hymne du vide*- NE RIEN JOUER"; break;
        case 22 : texte = "- CHANT DE L'ENVOL*- Hymne du vide*- Chant de l'esprit*- Ne rien jouer"; break;
        case 23 : texte = "- Chant de l'envol*- HYMNE DU VIDE*- Chant de l'esprit*- Ne rien jouer"; break;
        case 24 : texte = "- Chant de l'envol*- Hymne du vide*- CHANT DE L'ESPRIT*- Ne rien jouer"; break;
        case 25 : texte = "- Chant de l'envol*- Hymne du vide*- Chant de l'esprit*- NE RIEN JOUER"; break;
        case 26 : texte = "- HYMNE DU VIDE*- Ne rien jouer";
            if (gpJeu->getJoueur()->hasMelodie(2)) {id=33; chercheText();break;}
            break;
        case 27 : texte = "- Hymne du vide*- NE RIEN JOUER"; break;
        case 28 : texte = "- CHANT DE L'ESPRIT*- Ne rien jouer"; break;
        case 29 : texte = "- Chant de l'esprit*- NE RIEN JOUER"; break;
        case 30 : texte = "- CHANT DE L'ENVOL*- Chant de l'esprit*- Ne rien jouer"; break;
        case 31 : texte = "- Chant de l'envol*- CHANT DE L'ESPRIT*- Ne rien jouer"; break;
        case 32 : texte = "- Chant de l'envol*- Chant de l'esprit*- NE RIEN JOUER"; break;
        case 33 : texte = "- HYMNE DU VIDE*- Chant de l'esprit*- Ne rien jouer"; break;
        case 34 : texte = "- Hymne du vide*- CHANT DE L'ESPRIT*- Ne rien jouer"; break;
        case 35 : texte = "- Hymne du vide*- Chant de l'esprit*- NE RIEN JOUER"; break;
        case 36 : texte = "N : Village de Ruto*S : Plaine Est"; break;
        case 37 : texte = "S : Village de Ruto*E : Vers le dsert"; break;
        case 38 : texte = "Entre de la mine"; break;
        case 39 : texte = "O : Vers le Temple Latouane*E : Village de Ruto"; break;
        case 40 : texte = "Dsol, je n'avais qu'un seul flacon."; break;
        case 41 : texte = "Je vends un flacon pour 100 rubis, a t'intresse ?*              OUI ?            non  "; 
            if (gpJeu->getJoueur()->hasBouteille(0)) {id=40; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<100) idsuiv=44;
            else idsuiv=45;
            break;
        case 42 : texte = "Je vends un flacon pour 100 rubis, a t'intresse ?*              oui              NON ?"; idsuiv=43; break;
        case 43 : texte = "Reviens me voir si tu changes d'avis."; break;
        case 44 : texte = "Tu n'as pas assez !"; break;
        case 45 : texte = "Merci !"; break;
        case 46 : texte = "Tu as trouv un flacon vide !!!**Tu vas pouvoir stocker des potions dedans."; break;
        case 47 : texte = "Il y a un passage secret  l'Ouest du village qui mne au temple de Latouane, mais tu auras besoin de bombes pour l'emprunter."; break;
        case 49 :
            if (gpJeu->getJoueur()->getAvancement()>3 && !gpJeu->getJoueur()->hasObjet(O_SAC_BOMBES)) 
                texte = "Si tu cherches un sac de bombes, tu devrais aller voir l'homme qui travaille  la mine, il en utilise beaucoup.";
            else texte = "Ne trane pas dans mes pattes !"; break;
        case 50 : 
            if (gpJeu->getJoueur()->getAvancement()==5 || gpJeu->getJoueur()->getAvancement()==6)
                texte = "L'accs  la mine est strictement interdit sur ordre du maire depuis que des monstres en sortent.";
            else if (gpJeu->getJoueur()->getAvancement()==7)
                texte = "Tu dis que quelqu'un est peut-tre bloqu dans la mine ? Et alors ?";
            else if (gpJeu->getJoueur()->getAvancement()==8 || gpJeu->getJoueur()->getAvancement()==9)
                texte = "Le maire t'a autoris  passer ? Alors carte-toi !";
            else texte = "..."; break;
        case 54 : texte = "Bienvenue au village de Ruto.**Et tout  fait entre nous, mfie-toi de tout le monde ici..."; break;
        case 55 : texte = "Ce village  la faade prospre est en vrit le plus pauvre de Termina...*Et il ne faut pas compter sur le maire pour que a change..."; break;
        case 56 : texte = "Les touristes qui viennent dans ce village sont soit perdus, soit compltement fous.**Pour ma part j'ai toujours une carte sur moi."; break;
        case 57 : texte = "S : Vers la Plaine Est*O : Vers le temple de Latouane*E : Village de Ruto"; break;
        case 58 : texte = "S : Plaine Est"; break;
        case 59 : texte = "Temple de Latouane"; break;
        case 60 : texte = "E : Terres oublies"; break;
        case 61 : texte = "S : Village de Ruto*O : Mort certaine"; break;
        case 62 : texte = "Oasis frique"; break;
        case 63 : texte = "Grotte de la Fe"; break;
        case 64 : texte = "Temple de Din**La puissance des fes rcompensera les braves !"; break;
        case 65 : texte = "                     ???"; break;
        case 66 : texte = "Temple de Lanelle"; break;
        case 67 : texte = "O : Marais de la sorcire"; break;
        case 68 : texte = "E : Fort interdite"; break;
        case 69 : texte = "N : Plaine Est*O : Vers la ville de Rauru"; break;
        case 70 : texte = "N : Ville de Rauru"; break;
        case 71 : texte = "O : Plaine Ouest"; break;
        case 72 : texte = "N : Terres oublies*S : Ville de Rauru"; break;
        case 73 : texte = "N : Ville de Rauru*S : Lac de Lanelle*O : Plaine Ouest*E : Plaine Est"; break;
        case 74 : texte = "E : Plaine Est"; break;
        case 75 :  texte = "Dsol, je n'ai plus rien en stock."; break;
        case 76 : texte = "Je vends un meilleur bouclier pour 250 rubis, a t'intresse ?*              OUI ?            non  "; 
            if (gpJeu->getJoueur()->getBouclier()>1) {id=75; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<250) idsuiv=44;
            else idsuiv=45;
            break;
        case 77 : texte = "Je vends un meilleur bouclier pour 250 rubis, a t'intresse ?*              oui              NON ?"; idsuiv=43; break;
        case 78 : texte = "Tu as trouv un nouveau bouclier !!!**Ta dfense augmente d'un point, tu rsistes mieux aux attaques ennemies !!!"; break;
        case 79 : texte = "Pourquoi est-ce encore  moi de m'occuper de ces poules ???"; break;
        case 80 : texte = "J'aime balayer !"; break;
        case 81 : texte = "Rauru est la plus belle ville du pays, de nombreux visiteurs arrivent chaque jour pour la contempler."; break;
        case 82 : texte = "On dit qu'un instrument magique se trouve quelque part sur les terres de Termina. *Je me demande si je le verrai un jour..."; break;
        case 83 : texte = "Tu as trouv l'instrument magique ???**Et moi qui esprais que ce soit un saxo..."; break;
        case 84 : texte = "Mes parents se sont perdus."; break;
        case 85 : texte = "J'aime me promener !"; break;
        case 86 : texte = "S : Ville de Rauru*E : Maison hante"; break;
        case 87 : texte = "Maison hante**Venez enrichir notre collection d'mes !"; break;
        case 88 : texte = "E : Vers le Temple Latouane"; break;
        case 89 : texte = "Temple de Farore**La puissance des fes rcompensera les braves !"; break;
        case 90 : texte = "O : Village de Mido"; break;
        case 91 : texte = "N : Montagnes du destin"; break;
        case 92 : texte = "Temple de Zelda"; break;
        case 93 : texte = "O : Cimetire"; break;
        case 94 : texte = "Secret du dsert :*Soulve les pierres de l'oiseau dans le sens des aiguilles d'une montre en finissant par l'oeil pour ouvrir le chemin."; break;
        case 95 : texte = "S : Marais de la sorcire"; break;
        case 96 : texte = "E : Ville de Rauru"; break;
        case 97 : texte = "N : Plaine Ouest*S : Hutte de la sorcire"; break;
        case 98 : texte = "O : Village de Kasuto*E : Hutte de la sorcire"; break;
        case 99 : texte = "Hutte aux potions**Venez changer vos rubis contre les potions les plus puissantes du pays !!!"; break;
        case 100 : texte = "E : Lac de Lanelle"; break;
        case 101 : texte = "N : Cimetire*S : Village de Kasuto"; break;
        case 102 : texte = "Village de Kasuto**   -- Interdit aux humains (vivants) --"; break;
        case 103 : texte = "Astuce : Maintient Ctrl pour regarder autour de toi avec les flches de directions."; break;
        case 104 : texte = "N : Village de Kasuto*E : Marais de la sorcire"; break;
        case 105 : texte = "Colise des monstres**Venez nombreux !"; break;
        case 106 : texte = "T'as l'air plutt fort, tu devrais aller t'entraner dans l'arne au Sud du village. On dit qu'un objet trs utile y est cach..."; break;
        case 107 : texte = "Tiens ?*Une nouvelle espce ?**Est-ce que tu sais parler ?"; break;
        case 108 : texte = "Ce village est le dernier rempart contre l'humanit."; break;
        case 109 : texte = "Bonjour, je suis un monstre dbile."; break;
        case 110 : texte = "Bloqu ?***La solution n'est pourtant pas loin."; break;
        case 111 : texte = "S : Village de Kasuto"; break;
        case 112 : texte = "Temple de Xanto**Les morts ne racontent pas d'histoires..."; break;
        case 113 : texte = "Avez-vous dj essay le marteau sur les crnes ?"; break;
        case 114 : texte = "E : Plaine Ouest"; break;
        case 115 : texte = "Village de Mido"; break;
        case 116 : texte = "Est-ce que tous les jeunes de ton ge ont d'aussi mauvais gots vestimentaires ?"; break;
        case 117 : texte = "Bienvenue au village de Mido, mais ne te sens pas oblig de rester."; break;
        case 118 : texte = "Grrr... je pensais tre enfin tranquille ici..."; break;
        case 119 : texte = "Seul le vide infini pourra ter cette pierre."; break;
        case 120 : texte = "Temple de Nayru**La puissance des fes rcompensera les braves !"; break;
        case 121 : texte = "Passe du destin**Seul l'alli du bien et du mal franchira cette grotte."; break;
        case 122 : texte = "S : Village de Mido"; break;
        case 123 : texte = "Temple d'Ordinn"; break;
        case 124 : texte = "S : Plaine Ouest"; break;
        case 125 : texte = "La force des titans reviendra au hros lgendaire..."; break;
        case 126 : texte = "Tour du Destin**Hros d'Hyrule prends garde, ici trne dsormais le vil Ganon, ici se jouera l'avenir du monde."; break;
        case 127 : texte = "Flicitation !**Tu as russi  atteindre le sommet du mont Raplaplat !"; break;
        case 128 : texte = "Tu ne dois pas te transformer ici !!!"; break;
        case 129 : texte = "Tu ne peux pas entrer dans ce village sous cette apparence !!!"; break;
        case 130 : texte = "Link, c'est Pit. Je te parle par tlpathie. Tu ne dois en aucun cas te transformer dans un village !*Je te tlporte  l'extrieur."; break;
        case 131 : texte = "Tu as trouv une pe !!!**Appuie sur W pour attaquer ou maintiens W pour charger une super attaque."; break;
        case 132 : texte = "Tu as trouv la carte !!!**Appuie sur P pour voir le plan du donjon."; break;
        case 133 : texte = "Tu as trouv la boussole !!!**Les coffres et le boss du donjon sont dsormais indiqus sur la carte."; break;
        case 134 : texte = "Tu as trouv la cl du boss !!!**Sers-t'en pour accder  son repaire."; break;
        case 135 : texte = "Tu as trouv une petite cl.**Sers-t'en pour dverrouiller une porte."; break;
        case 136 : texte = "Tu as trouv un nouveau coeur !!!**Ta vie maximale augmente d'un coeur !!!"; break;
        case 137 : texte = "Tu as trouv un Graal !!!"; break;
        case 138 : texte = "Tu es venu me sauver ?*Merci beaucoup !"; 
            if (gpJeu->getMonde()->regionValue(0)==160*16) {
                if (gpJeu->getJoueur()->getCoffre(1,25)) {id=50; chercheText();break;}
                else idsuiv = 139;}
            if (gpJeu->getMonde()->regionValue(0)==180*16 
                && gpJeu->getMonde()->regionValue(1)==15*16) {
                if (gpJeu->getJoueur()->getCoffre(1,26)) {id=50; chercheText();break;}
                else idsuiv = 140;}
            if (gpJeu->getMonde()->regionValue(0)==180*16 
                && gpJeu->getMonde()->regionValue(1)==45*16)  {
                if (gpJeu->getJoueur()->getCoffre(1,27)) {id=50; chercheText();break;}
                else idsuiv = 141;}
            break;
        case 139 : texte = "En creusant des galeries nous avons dcouvert ce repaire de monstres..."; idsuiv=142; break;
        case 140 : texte = "Nous avons tous t capturs par les monstres vivants dans ces cavernes."; idsuiv=142; break;
        case 141 : texte = "Notre chef est  l'tage en dessous, va vite le sauver!"; idsuiv=142; break;
        case 142 : texte = "J'ai trouv a dans la mine, prends-la, a devrait t'aider!"; break;
        case 143 : 
            if (gpJeu->getJoueur()->hasObjet(O_SAC_BOMBES)) {id=50; chercheText();break;}
            texte = "Tu as vaincu le monstre de cette mine ???*Flicitation!!!"; idsuiv=144; break;
        case 144 : texte = "Je suis le chef des ouvriers, tu dis que tu me cherchais ?"; idsuiv=145; break;
        case 145 : texte = "Prends ce sac rempli de bombes, a devrait t'aider."; break;
        case 146 : texte = "Tu as trouv le Sac de Bombes !!!*Il est rempli en plus !!!*Appuie sur ENTREE pour les quiper, puis sur X pour en poser."; break;
        case 147 : texte = "Tu as trouv les Gants !!!**Tu peux dsormais soulever les pierres lgres en appuyant sur C."; break;
        case 148 : 
            if (gpJeu->getJoueur()->hasObjet(O_ARC)) {id=50; chercheText();break;}
            texte = "Je suis le bras droit du maire, il m'a envoy sauver sa fille...*Mais je me suis fait avoir, il n'y a rien  faire contre ces fantmes..."; idsuiv=149; break;
        case 149 : texte = "Ne reste pas ici, tu ne pourras rien faire avec tes armes actuelles..."; idsuiv=150; break;
        case 150 : texte = "Pour continuer ta qute, suis le chemin  l'Ouest de la ville. Cet arc te permettra d'atteindre la sphre et d'ouvrir le chemin..."; break;
        case 151 : texte = "Tu as trouv l'Arc !!!*Tu peux dsormais attaquer  distance et atteindre des cibles loignes !!!"; break;
        case 152 : 
            if (gpJeu->getJoueur()->getAvancement()>64) {id=153; chercheText();break;}
            texte = "Tu as vaincu le vampire et es venu me sauver ? Merci infiniment ! Mon pre est le maire de la ville, va le voir, je suis sre qu'il te rcompensera."; break;
        case 153 : texte = "Ne t'en fais pas pour moi, je peux rentrer sans aide maintenant que le vampire n'est plus."; break;
        case 154 : 
            if (gpJeu->getJoueur()->getAvancement()==13)
                texte = "Tu as reu l'autorisation du maire ?*Sois prudent dans ce cas, ceux qui s'aventurent l-bas ne reviennent jamais...";
            else if (gpJeu->getJoueur()->getAvancement()<13)
                texte = "Sur ordre du maire, l'accs  cette rgion est strictement interdit.";
            else texte = "..."; break;
        case 155 : texte = "Tu ne peux pas fuir maintenant!"; break;
        case 156 : texte = "Tu as trouv le Marteau !!!**Tu peux dsormais craser les obstacles gnants !!!"; break;
        case 157 : texte = "Tu as trouv le Grappin !!!**Tu peux dsormais franchir les prcipices !!!"; break;
        case 158 : texte = "Hall du Colise"; break;
        case 159 : texte = "Arne 1"; break;
        case 160 : texte = "Arne 2"; break;
        case 161 : texte = "Arne 3"; break;
        case 162 : texte = "Arne 4"; break;
        case 163 : texte = "Remise des prix"; break;
        case 164 : texte = "Arne spciale**Venez tenter le prix spcial !!!"; break;
        case 165 : texte = "Tu as trouv les Palmes !!!**Tu peux dsormais traverser les tendues d'eau !!!"; break;
        case 166 : texte = "Tu as trouv une Cotte de Maille !!!**Ta dfense augmente d'un point !!!"; break;
        case 167 : texte = "Tu as trouv une meilleure Cotte de Maille !!!   *Ta dfense augmente d'un point !!!"; break;
        case 168 : texte = "Hihihihihi !!!*Flicitation Link ! Tu as russi  te dbarrasser de ta maldiction. Et par la mme occasion tu m'as enfin libr !!!"; idsuiv=169; break;
        case 169 : texte = "Pour te rcompenser de tes efforts je ne te tuerai pas aujourd'hui, j'ai une mission plus importante."; idsuiv=170; break;
        case 170 : texte = "Si tu tiens  m'arrter, rejoins-moi au temple des morts si tu en as le courage.*Adieu ! Hihihihihi !!!"; break;
        case 171 : texte = "Link, c'est Zelda, je te parle par tlpathie. Je suis avec Pit, rejoins-nous vite, l'heure est grave."; break;
        case 172 : texte = "Bonjour Link, je t'attendais.**Je m'appelle Pit, j'ai t charg de surveiller cette grotte par la princesse Zelda."; idsuiv=173; break;
        case 173 : texte = "Elle m'a prvenu de ton arrive et m'a demand de t'aider.*Ma maison est juste  ct, nous serons mieux pour parler, suis-moi."; break;
        case 174 : texte = "Pit t'a demand de ne pas sortir de la fort."; break;
        case 175 : texte = "Tu as trouv la Baguette de Feu !!!**Tu peux dsormais envoyer de puissantes boules de feu !!!"; break;
        case 176 : 
            if ((gpJeu->getZone() == 23 && gpJeu->getJoueur()->getCoffre(8,19))
            || (gpJeu->getZone() == 24 && gpJeu->getJoueur()->getCoffre(9,24))
            || (gpJeu->getZone() == 25 && gpJeu->getJoueur()->getCoffre(10,21))) {
                id=50; chercheText();break;}
            texte = "Je t'attendais Link.*Je transmets la puissance de la desse  ton pe pour restituer le pouvoir d'Excalibur."; break;
        case 177 : 
            if (gpJeu->getJoueur()->getEpee()==5) {id=178; chercheText();break;}
            texte = "La puissance d'Excalibur a augment ! **Va vite au prochain temple !"; break;
        case 178 : texte = "Excalibur a atteint sa puissance maximale !!!  *Mme Oni-Link ne devrait pas rsister  sa lame !!!"; break;
        case 179 : texte = "Tu as trouv la Baguette de Glace !!!**Tu peux dsormais geler ce que tu veux !!!"; break;
        case 180 : texte = "Tu as trouv un nouveau bouclier !!!**Ta dfense a augment, tu rsistes dsormais mieux aux attaques ennemies !!!"; break;
        case 181 : texte = "Link, c'est Zelda, je te parle par tlpathie. N'entre surtout pas dans ce donjon sans tre parfaitement prpar, c'est sans doute un pige d'Oni-Link."; break;
        case 182 : texte = "Ainsi tu es venu ?*Tu dois sans doute vouloir mourir, je vais me faire un plaisir de t'exaucer.*Hihihihihi !!!"; break;
        case 183 : texte = "L'essence d'Oni-Link a t enferme dans le masque de l'Esprit !!!*Tu as russi !!!"; break;
        case 184 : texte = "Grrrr !!! Tu n'as tout de mme pas battu Oni-Link ??? Impressionnant...*J'imagine que tu ne t'attendais pas  me voir, nous sommes pourtant dans le monde des morts."; idsuiv=185; break;
        case 185 : texte = "Oni-Link m'a donn l'nergie dont j'avais besoin pour me re-matrialiser, je suis donc de retour plus tt que prvu.*Gwahahahahaha !!!"; idsuiv=186; break;
        case 186 : texte = "Au fait, tu te demandes peut-tre d'o vient Oni-Link ? C'est trs simple, la dernire fois je voulais m'assurer que tu ne te mettrais plus en travers de mon chemin, je me suis donc servi"; idsuiv=187; break;
        case 187 : texte = "de la Triforce pour te changer en monstre  ma solde. Hlas il n'y avait pas assez de tnbres en toi, cette transformation n'a donc pas t fulgurante..."; idsuiv=188; break;
        case 188 : texte = "Assez parl, j'ai de nombreux projets...*Je me ferais une joie de t'liminer, mais je n'en vois pas l'utilit..."; idsuiv=189; break;
        case 189 : texte = "Pour ton information, seules les cratures des tnbres peuvent s'chapper d'ici.*Alors adieu! Gwahahahahaha !!!"; break;
        case 190 : 
            if (!gpJeu->getJoueur()->getOni()) {id=184; chercheText();break;}
            texte = "Onily ? Alors il vient ce caf ???*Quoi ??? C'est toi Link ???"; idsuiv=184; break;
        case 191 : texte = "                Monde des Morts"; break;
        case 192 : texte = "Link, c'est Zelda, je te parle par tlpathie. C'est terrible, Ganon est de retour !!!"; idsuiv=193; break;
        case 193 : texte = "Il a recr son arme, qui s'apprte  attaquer Rauru!*Tu peux encore les arrter, va vite les intercepter sur la plaine Ouest!"; break;
        case 194 : texte = "Tu as trouv le grand Arc des Fes!!!**Tu tires dsormais des flches d'une puissance extraordinaire !!!"; break;
        case 195 : texte = "Tu as trouv la Triforce !!!"; break;
        
        case 197 : texte = "Tutoriel : appuie sur ESPACE pour parler, lire ou ouvrir un coffre, et sur ENTREE pour passer les textes  l'cran."; break;
        case 198 : texte = "Appuie sur C pour soulever un objet lger."; break;
        case 199 : texte = "Souhaites-tu sauvegarder ta partie ?**                    ? OUI ?*                      non  "; break;
        case 200 : texte = "Souhaites-tu sauvegarder ta partie ?**                      oui  *                    ? NON ?"; break;
        case 201 : texte = "                   Niveau 1 :                                                                                 Temple de Firone"; break;
        case 202 : texte = "                   Niveau 2 :                                                                                   Mine de Ruto"; break;
        case 203 : texte = "                   Niveau 3 :                                                                                Temple de Latouane"; break;
        case 204 : 
            if (gpJeu->getJoueur()->getEpee()>=2) 
                texte = "                   Niveau 9 :                                                                                   Manoir hant";
            else texte = "                   Niveau 4 :                                                                                   Manoir hant"; break;
        case 205 : texte = "                   Niveau 5 :                                                                                 Temple d'Ordinn"; break;
        case 206 : texte = "                   Niveau 6 :                                                                               Colise des Monstres"; break;
        case 207 : texte = "                   Niveau 7 :                                                                                Temple de Lanelle"; break;
        case 208 : texte = "                   Niveau 8 :                                                                                 Temple de Zelda"; break;
        case 209 : texte = "                   Niveau 10 :                                                                                 Temple de Din"; break;
        case 210 : texte = "                   Niveau 11 :                                                                                Temple de Nayru"; break;
        case 211 : texte = "                   Niveau 12 :                                                                                Temple de Farore"; break;
        case 212 : 
            if (gpJeu->getJoueur()->getX()>14*320) {id=191; chercheText();break;}
            texte = "                   Niveau 13 :                                                                                Temple de Xanto"; break;
        case 213 : texte = "                   Niveau ? :                                                                                  Temple secret"; break;
        case 214 : texte = "                 Niveau Final :                                                                                Tour du Destin"; break;
        case 215 : texte = "                Dj fatigu ?                  ?                CONTINUER                  ?             Sauvegarder et quitter                        Quitter sans sauvegarder           "; break;
        case 216 : texte = "                Dj fatigu ?                                   Continuer                     ?          SAUVEGARDER ET QUITTER           ?            Quitter sans sauvegarder           "; break;
        case 217 : texte = "                Dj fatigu ?                                   Continuer                                Sauvegarder et quitter              ?         QUITTER SANS SAUVEGARDER          ?"; break;
        case 218 : texte = "Aprs la dfaite de Ganon et la disparition de la Triforce, la lgende laisse croire que la paix dura...*Mais derrire chaque lgende se cache souvent une plus sombre ralit..."; idsuiv=402; break;
        case 220 : texte = "Oui... C'est par ici... *Nous y sommes presque..."; idsuiv=221; break;
        case 221 : texte = "Je suis dsole que tu ne puisses pas emmener d'armes... Mais tu comprends... Tu risques de te transformer  tout moment...*Ce serait trop dangereux..."; idsuiv=222; break;
        case 222 : texte = "Ca y est! C'est ici!*Ne bouge plus, j'active le portail...**Est-ce que tu es prt ?"; break;
        case 223 : texte = "Dbarrass de la maldiction de Ganon, Link put retourner  Hyrule sans risque.**La Triforce, Excalibur, ainsi que l'Ocarina furent remis  la famille royale d'Hyrule, tandis que le masque d'Oni-Link fut confi aux fes pour tre cach par del le temps et l'espace...**Le portail menant  Termina fut scell par la princesse Zelda et par Pit, pour ne jamais plus tre ouvert, et ce terrible chapitre fut effac de la lgende..."; idsuiv=224; break;
        case 224 : texte = "Le peuple d'Hyrule ne sut jamais ce qui se joua dans les mystrieuses contres de Termina, ni que le redoutable Ganon prparait dj son retour...**Mais ce que personne n'ignorait, fut le retour  Hyrule de son hros, qui sera toujours l pour dfendre le Royaume face aux tnbres."; break;
        case 225 : texte = "Tu as trouv un bouclier !!!**Ta dfense augmente d'un point, tu rsistes mieux aux attaques ennemies !!!"; break;
        case 226 : texte = "Pit t'attend dans la maison juste  ct."; break;
        case 227 : 
            if (gpJeu->getJoueur()->getMagieMax()>32) texte = "...";
            else texte = "Flicitation Link, tu as russi  me trouver. Je vais augmenter la capacit de ta rserve de magie pour te rcompenser."; break;
        case 228 : texte = "La capacit de ta jauge de magie a doubl !!!"; break;
        case 229 : texte = "Tu as trouv l'Ocarina du Temps !!!**Sa puissance est telle qu'il stoppe le temps lorsque tu souffles dedans !"; break;
        case 230 : texte = "Tu as trouv la Lanterne !!!**Tu peux dsormais faire jaillir des flammes!!!"; break;
        case 231 : texte = "Tu as trouv le Masque des Esprits !!!**Une trange aura s'en dgage..."; break;
        case 232 : 
            if (gpJeu->getJoueur()->getTutoriel()==3) {id=233; chercheText();break;}
            gpJeu->getJoueur()->setTutoriel(3);
            texte = "Flicitation, tu m'as trouve !!!**Je suis la grosse fe du dsert, j'organise des collectes de rubis !"; idsuiv=233; break;
        case 233 : texte = "Donne-moi vite 100 rubis !!!**              OUI ?            non  ";
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<100) {idsuiv=236; break;}
            if (gpJeu->getJoueur()->getFlecheMax()==70 && gpJeu->getJoueur()->getBombeMax()==30) {idsuiv=239; break;}
            if (gpJeu->getJoueur()->getFlecheMax()==70) {idsuiv=237; break;}
            if (gpJeu->getJoueur()->getBombeMax()==30) {idsuiv=238; break;}
            idsuiv = 237 + (rand()%2); break;
        case 234 : texte = "Donne-moi vite 100 rubis !!!**              oui              NON ?"; idsuiv=235; break;
        case 235 : texte = "Tu me fais perdre mon temps, oust!"; break;
        case 236 : texte = "Tu n'as mme pas assez!!!*Tu me fais perdre mon temps, oust!"; break;
        case 237 : texte = "J'augmente le nombre maximal de bombes que tu peux transporter, merci qui ???"; break;
        case 238 : texte = "J'augmente le nombre maximal de flches que tu peux transporter, merci qui ???"; break;
        case 239 : texte = "J'ai assez de rubis, disparait!"; break;
        case 240 : texte = "Tu as trouv les Gants d'Or !!!**Tu peux dsormais soulever les pierres lourdes en appuyant sur C."; break;
        case 241 : texte = "Je ne laisserai passer que les cratures malfaisantes."; 
            if (gpJeu->getJoueur()->getOni()) idsuiv=243; break;
        case 242 : texte = "Je ne laisserai passer que les cratures bienfaisantes."; 
            if (!gpJeu->getJoueur()->getOni()) idsuiv=244; break;
        case 243 : texte = "Tu as l'air malfaisant...*Ok tu peux passer!"; break;
        case 244 : texte = "Tu as l'air bienfaisant...*Ok tu peux passer!"; break;
        case 245 : 
            if (gpJeu->getJoueur()->getAvancement()==2) {id=250; chercheText();break;}
            texte = "Tu dois te demander o tu es.*Ici c'est Termina, et tu n'as pas besoin d'en savoir plus  ce sujet..."; idsuiv=246; break;
        case 246 : texte = "C'est une terre secrte qui aurait d le rester, la princesse Zelda n'aurait jamais d t'envoyer ici..."; idsuiv=247;  break;
        case 247 : texte = "Plus prcisment tu te trouves dans la fort de Termina. Dans cette fort se trouve un temple, et dans ce temple se trouve un objet sacr capable de conjurer n'importe quel malfice..."; idsuiv=248; break;
        case 248 : texte = "Trouve cet objet, puis reviens me voir.*J'ouvrirai le portail  nouveau pour que tu puisses repartir."; idsuiv=249; break;
        case 249 : texte = "Une dernire chose, ne quitte la fort  aucun prix! Ta prsence ici est secrte, et de plus, dans ton tat tu constitues une menace pour tous ceux que tu croises..."; idsuiv=250; break;
        case 250 : texte = "Bonne chance Link!"; break;
        case 251 : 
            if (gpJeu->getJoueur()->getAvancement()==3) {id=250; chercheText();break;}
            texte = "Quoi ??? Le graal n'a pas russi  te dbarrasser de la maldiction ??? C'est... impensable..."; idsuiv=252; break;
        case 252 : texte = "Cette maldiction doit tre terriblement puissante... Mais si tu y regardes de plus prs tout espoir n'est pas perdu..."; idsuiv=253; break;
        case 253 : texte = "Le graal a eu un effet sur toi, tu as d le remarquer.*Dsormais tu mets plus de temps  te transformer."; idsuiv=254; break;
        case 254 : texte = "Mais c'est  double tranchant... Car une fois  transform, tu le restes plus longtemps..."; idsuiv=255; break;
        case 255 : texte = "Ecoute-moi bien Link, il reste encore 4 autres graals dans les temples de Termina...*Il est dit que les 5 runis ont autant de pouvoir que la Triforce elle-mme."; idsuiv=256; break;
        case 256 : texte = "Grce au graal que tu as trouv, tu es dj un peu moins dangereux, je t'autorise donc  explorer librement Termina."; idsuiv=257; break;
        case 257 : texte = "Aventure-toi hors de cette fort, cherche et trouve ces graals, et tu seras sauv.*Mais tu ne dois en aucun cas t'aventurer dans un village en tant mtamorphos."; idsuiv=258; break;
        case 258 : texte = "Prends cette carte avec toi, elle te sera certainement utile...*Bonne chance!"; break;
        case 259 : 
            if (gpJeu->getJoueur()->getEpee()>=2) {id=271; chercheText();break;}
            texte = "Heureuse de te voir sain et sauf Link ! Maintenant que tu ne risques plus de te transformer, j'ai pens que tu apprcierais d'avoir ceci..."; break;
        case 260 : texte = "Tu as trouv Excalibur!!!**Sa puissance extraordinaire semble palpable !!!"; break;
        case 261 : texte = "Tu vas hlas en avoir grand besoin...*Oni-Link a t libr...*Nous aurions d le voir plus tt..."; idsuiv=262; break;
        case 262 : texte = "A chaque nouveau graal trouv, la frquence de tes transformations diminuait, mais la dure d'existence d'Oni-Link augmentait..."; idsuiv=263; break;
        case 263 : texte = "De plus, le comportement d'Oni-Link me semble trange...*Sa nature destructrice aurait d le pousser  attaquer un village..."; idsuiv=264; break;
        case 264 : texte = "Je devrais me rjouir, mais j'ai peur que de savoir qu'il a des desseins plus importants n'ait rien d'une bonne nouvelle..."; idsuiv=265; break;
        case 265 : texte = "Nous avons toutefois tabli un plan pour le vaincre. Ecoute-moi attentivement..."; idsuiv=266; break;
        case 266 : texte = "Excalibur est une arme redoutable, mais elle ne fera pas le poids contre Oni-Link...*...pour l'instant..."; idsuiv=267; break;
        case 267 : texte = "Il y a 3 temples secrets cachs  Termina. Dans ces temples se trouvent des fes dont les pouvoirs augmenteront la puissance de ton pe. Trouve-les toutes!"; idsuiv=268; break;
        case 268 : texte = "Tu seras alors en mesure de faire jeu gal avec Oni-Link.*Cependant, Oni-Link n'est qu'nergie et ne peut donc pas tre vaincu..."; idsuiv=269; break;
        case 269 : texte = "Le Masque des Esprits te permettra de l'enfermer  jamais. Pour ce faire, tu devras trouver ce masque, trouver l'Ocarina magique et trouver la mlodie qui l'enfermera..."; idsuiv=270; break;
        case 270 : texte = "Ta qute ne fait que commencer..."; break;
        case 271 : texte = "Trouve les 3 fes, le masque, l'Ocarina, et le chant de l'esprit, puis va affronter Oni-Link!"; break;
        case 272 : 
            if (gpJeu->getJoueur()->getEpee()<2) {id=50; chercheText();break;}
            texte = "Comme tu le sais, Excalibur peut vaincre les fantmes, renvoyer les attaques magiques, et dtruire les barrires magiques...*Fais-en bon usage..."; break;
        case 273 : texte = "Il n'y a pas de temps  perdre!*Va immdiatement  la plaine Ouest intercepter l'arme de Ganon!"; break;
        case 274 : texte = "Vite Link, t'attends quoi ?*Nol ???"; idsuiv=275; break;
        case 275 : texte = "Euh... Comment a et moi ?*Je... euh... ...protge la princesse, voil!*Tu crois que c'est grce  qui si elle n'a pas t enleve cette fois ? Hein ?"; break;
        case 276 : 
            if (gpJeu->getJoueur()->getAvancement()==69) {id=282; chercheText();break;}
            texte = "Link... il y a une chose que j'aurais d te dire depuis le dbut...*Sur ce monde, Termina..."; idsuiv=277; break;
        case 277 : texte = "Ce monde est trs rcent, il a t fabriqu de toute pice par la Triforce et par un voeu... Les gens, leurs souvenirs et leurs histoires ont ainsi t fabriqus..."; idsuiv=278; break;
        case 278 : texte = "Oui... Tu as bien devin, c'est moi qui ai demand  la Triforce de crer ce monde... C'est un monde conu pour contenir tout ce dont on peut avoir besoin."; idsuiv=279; break;
        case 279 : texte = "Tu y as trouv les graals, Oni-Link a retrouv son matre, et Ganon a retrouv...*...la Triforce..."; idsuiv=280; break;
        case 280 : texte = "J'ai cr ce monde pour servir de cachette  la Triforce, mais Ganon l'a retrouve..."; idsuiv=281; break;
        case 281 : texte = "Link! Ce pays et ces gens ont t crs, mais ils sont bien rels maintenant! Si on ne fait rien, ce monde ressemblera bientt  l'ex-monde des tnbres!"; idsuiv=282; break;
        case 282 : texte = "Je m'en remets une fois de plus  toi, Link, sauve ce monde!"; break;
        case 283 : 
            texte = "Bienvenue  la maison d'tudes des monstres en tout genre!"; 
            if (gpJeu->getJoueur()->getOni()) {idsuiv=290; break;}
            if (gpJeu->getJoueur()->hasObjet(O_ENCYCL)) {
                if (gpJeu->getJoueur()->getEpee()>1 
                && gpJeu->getJoueur()->hasObjet(O_ENCYCL)==1) {
                    gpJeu->getJoueur()->trouveObjet(O_ENCYCL,2);
                    idsuiv=294; break;
                }
                if (gpJeu->getJoueur()->getEnnemi(19)
                && gpJeu->getJoueur()->getEnnemi(24)
                && gpJeu->getJoueur()->getEnnemi(35)
                && gpJeu->getJoueur()->hasObjet(O_ENCYCL)!=3) {
                    gpJeu->getJoueur()->trouveObjet(O_ENCYCL,3);
                    idsuiv=296; break;
                }
                if (gpJeu->getJoueur()->nbEnnemis()==62) {idsuiv=297; break;}
                if (gpJeu->getJoueur()->getSolde()>0) {idsuiv=291; break;}
            }
            else {idsuiv=284; gpJeu->getJoueur()->trouveObjet(O_ENCYCL);}
            break;
        case 284 : texte = "Tu te souviens sans doute de moi, tu m'as t d'une grande aide  Hyrule.*Euh... Tu te demandes comment je suis arriv  Termina ? Euh... peu importe!"; idsuiv=285; break;
        case 285 : texte = "Ce vaste monde regorge de monstres, alors je ne pouvais pas ne pas tre du voyage!"; idsuiv=286; break;
        case 286 : texte = "Je vais donc rpertorier chaque monstre dans une nouvelle encyclopdie!**Avec ton aide, cela va de soit."; idsuiv=287; break;
        case 287 : texte = "Je n'ai hlas plus de quarts de coeurs, mais les devises sont ma nouvelle devise.*Je te paierai un bon prix chaque nouveau monstre ajout  l'encyclopdie."; idsuiv=288; break;
        case 288 : texte = "Passe me voir rgulirement pour obtenir tes gains. Si tu ne peux pas tout transporter, je garderais l'excdent pour ta prochaine venue."; idsuiv=289; break;
        case 289 : texte = "Il suffit de battre de nouveaux monstres pour qu'ils soient ajouts.*Tu peux consulter l'encyclopdie en appuyant sur M!"; break;
        case 290 : 
            texte = "Mmm... tu es un drle de spcimen...";
            if (gpJeu->getJoueur()->getEnnemi(75) 
            || !gpJeu->getJoueur()->hasObjet(O_ENCYCL)) break;
            texte += "*Je t'ajoute  l'encyclopdie!!!"; break;
        case 291 : 
            os << gpJeu->getJoueur()->getSolde();
            texte = "Je te dois " + os.str() + " rubis.";
            idsuiv=292; break;
        case 292 : texte = "Veux-tu tre pay maintenant ?**              OUI ?            non  "; break;
        case 293 : texte = "Veux-tu tre pay maintenant ?**              oui              NON ?"; break;
        case 294 : texte = "J'ai un scoop pour toi, des monstres que tu avais vaincu  Hyrule ont mystrieusement t ramens  la vie! Ils se baladeraient dans les contres de Termina..."; idsuiv=295; break;
        case 295 : texte = "Il y en aurait 3.*Si tu les bats, je t'offrirais un prix... spcial..."; break;
        case 296 : texte = "Tu as vaincu les 3 monstres rares ???*...*Ta rcompense t'attends au sous-sol..."; break;
        case 297 : texte = "Tu as vaincu chaque monstre...*C'est incroyable..."; break;
        case 298 : texte = "Bonjour Link, comment vont tes bombes ?"; break;
        case 299 : texte = "Je n'ai plus de prix  mettre en jeu, dsol."; break;
        case 300 : texte = "Un de ces coffres contient un quart de coeur, tu veux tenter ta chance pour 10 rubis ?*Tu ne pourras ouvrir qu'un seul coffre, ok ?              OUI ?            non  ";
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<10) idsuiv=44; break;
        case 301 : texte = "Un de ces coffres contient un quart de coeur, tu veux tenter ta chance pour 10 rubis ?*Tu ne pourras ouvrir qu'un seul coffre, ok ?              oui              NON ?"; break;
        case 302 : texte = "Choisis un coffre."; break;
        case 303 : texte = "Hey! Il faut payer pour ouvrir un de mes coffres!!!"; break;
        case 304 : texte = "Perdu! Ce coffre est vide."; break;
        case 305 : 
            if (gpJeu->getJoueur()->getAsile()==2) {id=342; chercheText(); break;}
            texte = "Qu'est-ce que je vous sers ?"; break;
        case 306 : texte = "Tu cherches l'homme qui travaille  la mine ? Personne ne l'a revu depuis qu'ils ont condamn la mine... Il est peut-tre encore coinc dedans..."; break;
        case 307 : texte = "Ce saloon tait trs frquent...*...autrefois..."; break;
        case 308 : texte = "JE suis le maire de ce village, et JE n'ai pas envie de te parler!"; break;
        case 309 : texte = "Tu dis que quelqu'un est peut-tre bloqu dans la mine ?**... ... ..."; 
            if (gpJeu->getJoueur()->getAvancement()==8) {id=308; chercheText();} 
            else idsuiv=310; break;
        case 310 : texte = "Trs bien, donne-moi 10 rubis et je t'autorise  accder  la mine. Ok ?*              OUI ?            non  ";
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<10) idsuiv=44; 
            else idsuiv=312; break;
        case 311 : texte = "Trs bien, donne-moi 10 rubis et je t'autorise  accder  la mine. Ok ?*              oui              NON ?"; break;
        case 312 : texte = "March conclu, va parler au garde, il te laissera passer..."; break;
        case 313 : texte = "Un petit coeur pour 5 rubis ?**              OUI ?            non  ";
            if (gpJeu->getJoueur()->getVie() == gpJeu->getJoueur()->getVieMax()) {id=315; chercheText(); break;}
            else if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<5) idsuiv=44; break;
        case 314 : texte = "Un petit coeur pour 5 rubis ?**              oui              NON ?"; break;
        case 315 : texte = "Tu n'as pas besoin de a."; break;
        case 316 : texte = "Une petite fiole de magie pour 15 rubis ?**              OUI ?            non  ";
            if (gpJeu->getJoueur()->getMagie() == gpJeu->getJoueur()->getMagieMax()) {id=315; chercheText(); break;}
            else if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<15) idsuiv=44; break;
        case 317 : texte = "Une petite fiole de magie pour 15 rubis ?**              oui              NON ?"; break;
        case 318 : texte = "Une grande fiole de magie pour 25 rubis ?**              OUI ?            non  ";
            if (gpJeu->getJoueur()->getMagie() == gpJeu->getJoueur()->getMagieMax()) {id=315; chercheText(); break;}
            else if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<25) idsuiv=44; break;
        case 319 : texte = "Une grande fiole de magie pour 25 rubis ?**              oui              NON ?"; break;
        case 320 : texte = "Choisis ce que tu veux.*"; break;
        case 321 : texte = "10 flches pour 20 rubis ?**              OUI ?            non  ";
            if (gpJeu->getJoueur()->getFleche() == gpJeu->getJoueur()->getFlecheMax()
            || !gpJeu->getJoueur()->hasObjet(O_ARC)) {id=315; chercheText(); break;}
            else if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<20) idsuiv=44; break;
        case 322 : texte = "10 flches pour 20 rubis ?**              oui              NON ?"; break;
        case 323 : texte = "5 bombes pour 30 rubis ?**              OUI ?            non  ";
            if (!gpJeu->getJoueur()->hasObjet(O_SAC_BOMBES)) {id=325; chercheText(); break;}
            else if (gpJeu->getJoueur()->getBombe() == gpJeu->getJoueur()->getBombeMax()) {id=315; chercheText(); break;}
            else if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<30) idsuiv=44; break;
        case 324 : texte = "5 bombes pour 30 rubis ?**              oui              NON ?"; break;
        case 325 : texte = "Il te faut un sac de bombes pour acheter ceci."; break;
        case 326 : texte = "Reviens me voir lorsque tu auras un flacon vide et je te vendrais des potions."; break;
        case 327 : texte = "Les potions rouges redonnent de l'nergie alors que les potions vertes redonnent de la magie."; 
            if (gpJeu->getJoueur()->hasBouteille(0)!=1 
            && gpJeu->getJoueur()->hasBouteille(1)!=1
            && gpJeu->getJoueur()->hasBouteille(2)!=1) {id=326; chercheText(); break;}
            idsuiv=328; break;
        case 328 : texte = "Que dsires-tu ?*                ? POTION ROUGE ?*                ? potion verte ?*                ?     rien     ?"; idsuiv=331; break;
        case 329 : texte = "Que dsires-tu ?*                ? potion rouge ?*                ? POTION VERTE ?*                ?     rien     ?"; 
            if (!gpJeu->getJoueur()->hasObjet(O_LANTERNE)) idsuiv=315;
            idsuiv=333; break;
        case 330 : texte = "Que dsires-tu ?*                ? potion rouge ?*                ? potion verte ?*                ?     RIEN     ?"; break;
        case 331 : texte = "Une potion rouge pour 60 rubis ?**              OUI ?            non  "; 
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<60) idsuiv=44; break;
        case 332 : texte = "Une potion rouge pour 60 rubis ?**              oui              NON ?"; break;
        case 333 : texte = "Une potion verte pour 40 rubis ?**              OUI ?            non  ";
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<40) idsuiv=44; break;
        case 334 : texte = "Une potion verte pour 40 rubis ?**              oui              NON ?"; break;
        case 335 : texte = "Tu as trouv une potion rouge !!!**Bois-la pour restaurer toute ton nergie!!!"; break;
        case 336 : texte = "Tu as trouv une potion verte !!!**Bois-la pour restaurer toute ta magie!!!"; break;
        case 337 : texte = "Tu as trouv une potion bleue !!!**Bois-la pour restaurer ton nergie et ta magie!!!"; break;
        case 338 : texte = "DROIT   D'ASIIIIIILE !!!!!!!!"; break;
        case 339 : texte = "Ah vous aussi... les poules ? Hic!*Terribles aussi ces bestioles... Hic!"; break;
        case 340 : 
            if (gpJeu->getJoueur()->getAsile()==2) {id=339; chercheText(); break;}
            if (gpJeu->getJoueur()->hasCristal(3)) {id=341; chercheText(); break;}
            texte = "J'tais un pcheur dans le temps... Hic!*Mais depuis que je L'ai vu... Hic!*Cette terrible bte... Hic!*Dans le lac... Hic!"; break;
        case 341 : texte = "Tu as vaincu le monstre du lac tu dis ???*... ... ...*De toute faon j'ai peur de l'eau... Hic!*(je prfre le vin) Hic!"; break;
        case 342 : texte = "H! H! H!"; break;
        case 343 : 
            if (gpJeu->getJoueur()->getAvancement()==11) {id=344; chercheText(); break;}
            if (gpJeu->getJoueur()->getAsile()==3) {id=347; chercheText(); break;}
            if (gpJeu->getJoueur()->getRaplaplat()) {id=348; chercheText(); break;}
            texte = "Bonjour! Je sais tout sur tout de ce qui se dit en ville, viens me voir si tu as besoin d'infos."; break;
        case 344 : 
            if (gpJeu->getJoueur()->getAvancement()!=11) {id=343; chercheText(); break;}
            texte = "Tu veux savoir pourquoi le maire est si silencieux ?*D'accord, mais je ne t'ai rien dit, ok ?"; idsuiv=345; break;
        case 345 : texte = "Cette ville a un terrible secret...*La nuit, des jeunes filles se font enlever, on ne les retrouve jamais... Je n'ose mme plus sortir..."; idsuiv=346; break;
        case 346 : texte = "La nuit dernire, d'aprs les rumeurs, ce serait la fille du maire qui aurait disparu..."; break;
        case 347 : 
            if (gpJeu->getJoueur()->getRaplaplat()) idsuiv=348;
            texte = "Bonjour! Monsieur-qui-a-peur-des-poules,*Hi! Hi! Hi!"; break;
        case 348 : texte = "On raconte que tu aurais escalad le mont Raplaplat ? Flicitation! Hi! Hi! Hi!"; break;
        case 349 : 
            if (gpJeu->getJoueur()->getAvancement()==13) {id=50; chercheText(); break;}
            texte = "Tu... tu es au courant pour ma fille ?*C'est affreux... Ma chre fille..."; idsuiv=350;break;
        case 350 : texte = "D'aprs l'enqute que je mne depuis le dbut de ces vnements, les jeunes filles enleves seraient emmenes au manoir au Nord du village..."; idsuiv=351; break;
        case 351 : texte = "J'ai dj envoy la garde l bas, mais personne n'en est revenu..."; idsuiv=352; break;
        case 352 : texte = "Alors ce matin, en dcouvrant que ma fille n'tait plus l, j'ai suppli mon homme de main de me la ramener... C'est un combattant hors pair, mais il est anormalement long..."; idsuiv=353; break;
        case 353 : texte = "Tu as l'air d'tre un combattant, veux-tu aller voir ce qui s'y passe ?*Tu seras grandement rcompens si tu sauves ma fille."; idsuiv=354; break;
        case 354 : texte = "Va voir le garde au Nord-Ouest du village, il te laissera passer."; break;
        case 355 : 
            if (gpJeu->getJoueur()->hasMelodie(1)) {id=358; chercheText(); break;}
            texte = "Ma fille m'a tout racont, je te dois normment!!!"; idsuiv=356; break;
        case 356 : texte = "Ecoute attentivement, je vais t'apprendre un chant qui se transmet dans ma famille de gnration en gnration :*L'Hymne du Vide!"; break;
        case 357 : texte = "Tu as appris l'Hymne du Vide!!!**Utilise l'Ocarina pour le jouer!"; break;
        case 358 : texte = "L'Hymne du Vide a de mystrieux pouvoirs...*...Je crois."; break;
        case 359 : texte = "Bonjour monsieur-mon-sauveur!"; break;
        case 360 : 
            if (gpJeu->getJoueur()->hasBouteille(0)!=1 
            && gpJeu->getJoueur()->hasBouteille(1)!=1
            && gpJeu->getJoueur()->hasBouteille(2)!=1) {id=326; chercheText(); break;}
            texte = "Une potion bleue pour 160 rubis ?*Tu ne seras pas du...*              OUI ?            non  "; 
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<160) idsuiv=44; break;
        case 361 : texte = "Une potion bleue pour 160 rubis ?*Tu ne seras pas du...*              oui              NON ?"; break;
        case 362 : 
            if (gpJeu->getJoueur()->hasObjet(O_GRAPPIN)) {id=364; chercheText(); break;}
            texte = "Bonjour, ce n'est pas tous les jours qu'un monstre aussi puissant nous fait l'honneur de sa visite..."; idsuiv=363; break;
        case 363 : texte = "Tu devrais aller t'amuser dans le colise au Sud-Ouest du village, il y a un prix intressant  gagner..."; break;
        case 364 : texte = "Tu as gagn le prix du colise ?*Impressionnant..."; break;
        case 365 : texte = "Si tu crois tre le monstre le plus effrayant de Termina, c'est que tu prends tes rves pour la ralit mon pauvre ami..."; idsuiv=366; break;
        case 366 : texte = "Crois-moi sur parole, le monstre du lac est de loin le plus terrifiant des monstres, je te conseille d'viter par dessus tout de l'affronter."; break;
        case 367 : texte = "Le colise au Sud d'ici est le principal divertissement de ce village.*Le but est d'aller le plus loin possible avant de se faire tuer."; idsuiv=368; break;
        case 368 : texte = "Mais on a toujours beaucoup de mal  trouver des volontaires, alors le chef a t contraint d'y placer des items de grande valeur."; break;
        case 369 : 
            texte = "Veux-tu entendre mon histoire pour 10 rubis ?**              OUI ?            non  "; 
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<10) idsuiv=44; break;
        case 370 : texte = "Veux-tu entendre mon histoire pour 10 rubis ?**              oui              NON ?"; break;
        case 371 : texte = "D'aprs le chef, au Nord d'ici se trouve le temple de Xanto, galement connu sous le nom de temple des morts..."; idsuiv=372; break;
        case 372 : texte = "Ce temple serait un passage du monde des vivants au monde des morts... Mais pour accder au monde des morts, il faudrait traverser un labyrinthe infranchissable..."; idsuiv=373; break;
        case 373 : texte = "Paie-moi  nouveau si tu veux que je rpte."; break;
        case 374 : 
            if (gpJeu->getJoueur()->hasObjet(O_MASQUE)==1) {id=376; chercheText(); break;}
            if (gpJeu->getJoueur()->hasObjet(O_MASQUE)==2) {id=380; chercheText(); break;}
            texte = "Tu cherches le Masque des Esprits ?*... Tiens donc..."; idsuiv=375; break;
        case 375 : texte = "Non, je ne sais pas o il se trouve, mais je sais comment l'utiliser.*Reviens me voir si tu le trouves et je pourrais t'aider."; break;
        case 376 : 
            if (gpJeu->getJoueur()->hasMelodie(2)) {id=379; chercheText(); break;}
            texte = "Tu as trouv le Masque des Esprits ??? *...*Alors coute-moi bien, je vais t'apprendre  l'utiliser."; idsuiv=377; break;
        case 377 : texte = "En prsence d'un esprit affaiblit, tu devras jouer le chant des esprits  l'aide de ton ocarina.*Ecoute le chant des esprits!"; break;
        case 378 : texte = "Tu as appris le chant des esprits!!!**Utilise l'Ocarina pour le jouer!"; break;
        case 379 : texte = "Le Masque des Esprits ne sert qu'une fois, fais-en bon usage..."; break;
        case 380 : texte = "Tu as enferm un esprit terriblement puissant...*Veille  ce qu'il ne tombe pas en de mauvaises mains..."; break;
        case 381 : texte = "Notre village accueille rarement des visiteurs...*Cela vient peut-tre du fait que nous avons bloqu l'entre..."; break;
        case 382 : 
            if (gpJeu->getJoueur()->hasObjet(O_BFEU)) {id=386; chercheText(); break;}
            if (gpJeu->getJoueur()->getAvancement()==66) {id=385; chercheText(); break;}
            texte = "Tu es le seul visiteur que j'ai eu depuis que je vis ici...*Je suis un ancien aventurier, j'tais trs dou comme chasseur de trsor..."; idsuiv=383;break;
        case 383 : texte = "Un jour j'ai entendu l'histoire du trsor de la pyramide, un objet magique...*Mais ce dsert causa ma perte, je n'ai jamais pu le traverser, il est bien trop dangereux..."; idsuiv=384; break;
        case 384 : texte = "Tu sembles aussi dtermin que je l'tais dans mon jeune temps... Je te propose un march..."; idsuiv=385; break;
        case 385 : texte = "Ramne-moi le trsor de la pyramide, et je t'offrirais mon plus prcieux trsor."; break;
        case 386 : 
            if (gpJeu->getJoueur()->hasMelodie(0)) {id=389; chercheText(); break;}
            texte = "Tu as trouv le trsor ???*Une baguette de feu, hein ?*...*..."; idsuiv=387; break;
        case 387 : texte = "Cette baguette te servira plus qu' moi...*Tu peux la garder...*"; idsuiv=388; break;
        case 388 : texte = "Accepte cette rcompense pour avoir montr  un vieillard le trsor qu'il a cherch toute sa vie...*Le chant de l'envol!!!"; break;
        case 389 : texte = "Jou avec un instrument magique, ce chant permet de se tlporter. J'esprais pouvoir traverser le dsert avec, mais je n'ai jamais trouv l'instrument adquat..."; break;
        case 390 : texte = "Tu as appris le chant de l'envol!!!**Utilise l'Ocarina pour le jouer!"; break;
        case 391 : texte = "Link! C'est Pit!!!*Qu'est ce que tu fabriques???*Fonce  la plaine ouest!!!"; break;
        case 392 : texte = "Link, c'est Zelda, flicitation!!!*Rauru est en scurit, pour le moment...*Va  la tour du destin au sommet de la montagne et stoppe Ganon!"; break;
        case 393 : texte = "Tutoriel : lorsque la jauge de colre est pleine, tu te transformes en Oni-Link.*Ton allonge et ta force augmentent alors que ta dfense diminue."; idsuiv=394; break;
        case 394 : texte = "En Oni-Link, tu ne peux plus utiliser les objets quipables, mais tu peux te tlporter  l'entre lorsque tu es dans un donjon en appuyant sur T."; idsuiv=395; break;
        case 395 : texte = "A chaque ennemi vaincu par Oni-Link, ta jauge diminue. Une fois vide, Link reprend sa forme normale."; break;
        case 396 : texte = "Chef de projet, concepteur et programmeur :                                                                  Vincent Jouillat"; break;
        case 397 : texte = "Scnariste :                                                                                                      Lobalz"; break;
        case 398 : texte = "Aide aux Graphismes :                                                                                           Harvestland"; break;
        case 399 : texte = "Aide aux Graphismes :                                                                                         Solne Jouillat"; break;
        case 400 : texte = "Illustrateur :                                                                                                    Raiden"; break;
        case 401 : texte = "Tu as trouv la carte de Termina !!!**Appuie sur P lorsque tu es  l'extrieur pour la visualiser."; break;
        case 402 : texte = "La lgende oublie qu' la suite de ces vnements son hros fut frapp par une terrible maldiction..."; idsuiv=403; break;
        case 403 : texte = "Jour aprs jour, Link se transformait en un monstre au pouvoir destructeur incontrlable surnomm Oni-Link..."; idsuiv=404; break;
        case 404 : texte = "Banni d'Hyrule, Link demanda conseil  la Princesse Zelda."; idsuiv=405; break;
        case 405 : texte = "Cette dernire lui indiqua son tout dernier espoir : un portail vers un monde secret..."; break;
        case 406 : texte = "Partie sauvegarde."; break;
        case 407 : texte = "Tu n'as pas besoin de boire cette potion maintenant."; break;
        case 408 : texte = "AIDE : Appuie sur F1 pour consulter l'aide."; break;
        case 409 : texte = "Grrrr... Comment as-tu pu t'chapper du monde des morts et arriver jusqu'ici ???"; idsuiv=410; break;
        case 410 : texte = "Pourquoi t'enttes-tu  venir m'affronter ? *Mme si tu me terrasses je reviendrais toujours  la vie."; idsuiv=411; break;
        case 411 : texte = "Ta qute est vaine, abandonne tout espoir! **Let's rock, baby!"; break;
    }
    
    
}

void Texte::affiche(SDL_Surface* gpScreen, std::string s, int a, int b) {
    for (int i = 0; i < (int)s.length(); i++) {
        afficheLettre(gpScreen, s.at(i),a,b);
        a+=6;
    }
}

void Texte::draw(SDL_Surface* gpScreen) {
    
    if (cadre) drawCadre(gpScreen);
    
    if (id==3 && texte == "Tu as trouv un quart de coeur !!!") {
        SDL_Rect src; SDL_Rect dst;
        src.x=16*(gpJeu->getJoueur()->nbQuarts()%4);
        if(src.x==0)src.x=16*4;
        src.y=0; src.w=16; src.h=16; dst.x=160-8; dst.y=120-8+16*5;
        SDL_BlitSurface(imageCoeur, &src, gpScreen, &dst);
    }
    
    int a = x+8; int b = y+8;
    for (int i = 0; i < av; i++) {
        afficheLettre(gpScreen, texte.at(i),a,b);
        a+=6;
        if (a > x+w-16) {a=x+8; b+=16;}
    }
    
    if(SDL_GetTicks() > lastAnimTime + vitesse && def && av < (int)texte.length()) {
        lastAnimTime = SDL_GetTicks();
        do av++;
        while (av < (int)texte.length() && texte.at(av-1) == ' ');
        if (texte.at(av-1) != ' ') gpJeu->getAudio()->playSound(0,1);
    }
}

bool Texte::isFinished() {return (av==(int)texte.length());}

int Texte::getId() {return id;}

void Texte::changeId(int i) {
    id=i; idsuiv=0; buffer="";
    chercheText();
    decoupeText();
    if (av>(int)texte.length()) av=(int)texte.length();
}

void Texte::drawCadre(SDL_Surface* gpScreen) {
    SDL_Rect src;
    SDL_Rect dst;
    
    src.w=8; src.h=8; src.x = 103; src.y = 100; dst.x = x; dst.y = y;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    
    src.x = 112;
    for (int i = 8; i < w-8; i+=16) {
        dst.x = x+i; src.w=16;
        while (dst.x + src.w > x+w && src.w>0) src.w--;
        if (src.w>0) SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    }
    
    src.w=8; src.x = 129; dst.x = x+w-8;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    
    src.y = 109; src.w=8;
    for (int j = 8; j < h-8; j+=16) {
        dst.y = y + j;
        src.x = 103; dst.x = x; src.h=16;
        while (dst.y + src.h > y+h && src.h>0) src.h--;
        if (src.h>0) SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    
        src.x = 129; dst.x = x+w-8;
        if (src.h>0)SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    }
    
    src.h=8; src.x = 103; src.y = 126; dst.x = x; dst.y = y+h-8;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    
    src.x = 112;
    for (int i = 8; i < w-8; i+=16) {
        dst.x = x+i; src.w=16;
        while (dst.x + src.w > x+w && src.w>0) src.w--;
        if (src.w>0) SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    }
    
    src.w=8; src.x = 129; dst.x = x+w-8;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
}

void Texte::setTexte(int idTxt, int vx, int vy, int vw, int vh, bool cadr, bool defil, int vit) {
    if (idTxt == 0) return;
    id = idTxt; 
    idsuiv = 0;
    buffer = "";
    chercheText();
    
    x = vx; y = vy; w = vw; h = vh;
    decoupeText();
        
    def=defil;
    if (def) av = 0;
    else av = texte.length();
    
    cadre = cadr;
    
    vitesse = vit;
}

void Texte::decoupeText() {
    //compte le nombre de caractres possibles et largeur et en hauteur
    int nbcol = (w-16)/6 -1;
    int nblig = (h-16)/16;
    int tailleMax = nbcol * nblig;
    int taille;
    
    //parcours du texte  afficher;  chaque dbut de mot, 
    //vrifie que le mot peut tenir sur la ligne
    for (int i = 0; i < (int)texte.length(); i++) {
        
        //supprime les espaces isols en dbut de ligne
        if (texte.at(i)==' ' && texte.at(i+1)!=' ' && i%nbcol == 0) texte.erase(i,1);
        //recherche du dbut du prochain mot
        while(texte.at(i)==' ' && i < (int)texte.length()-1) i++;
        
        //saute une ligne si trouve une toile
        if (texte.at(i)=='*') {
            texte.erase(i,1);//replace(i, 1, " ");
            int nb = (nbcol)-(i%(nbcol));
            for (int j = 0; j < nb; j++) texte.insert(i," ");
            continue;
        }
        
        //si le mot dpasse
        taille = tailleMot(i);
        if ((i%nbcol)+taille>nbcol) {
            if  (i < tailleMax) {
                //si le mot ne tient pas sur une ligne, on le coupe avec des tirets
                if (taille>nbcol) {
                    texte.insert(((i/nbcol)+1)*nbcol-1,"--");
                    i = 1+((i/nbcol)+1)*nbcol;
                }
                //sinon, on ajoute des espaces pour faire commencer le mot  la ligne
                else while((i%nbcol) != 0) {texte.insert(i," "); i++;}
            }
        }
        
    }
    
    // si le texte est trop grand, on le coupe en deux
    if ((int)texte.length() > tailleMax) {
        buffer = texte.substr(tailleMax);
        texte = texte.substr(0, tailleMax);
    }
}

int Texte::tailleMot(int deb) {
    int i = deb;
    int total = 0;
    while (texte.at(i)!=' ') {total++; i++; if (i >= (int)texte.length()) return total;}
    return total;
}

void Texte::afficheLettre(SDL_Surface* gpScreen, char c, int vx, int vy) {
    SDL_Rect src;
    SDL_Rect dst;
    
    int val = (int)c;
    
    dst.x=vx; dst.y=vy;
    src.h=16;src.w=8;
    
    if(val==32) return;
    
    // /
    if(val==47) {src.x=52;src.y=151;}
    
    // @ hylien
    if(val==64) {src.x=4;src.y=151;}
            
    // + hylien
    if(val==43) {src.x=20;src.y=151;}
            
    // = hylien
    if(val==61) {src.x=36;src.y=151;}
            
    //minuscules a-z
    if(val>=97 && val<=122) {src.x=4+16*((val-97)%10); src.y=52+16*((val-97)/10);}
            
    //majuscules A-Z
    if(val>=65 && val<=90) {src.x=6+16*((val-65)%10); src.y=2+16*((val-65)/10);}   
    // 
    if(val==-25) {src.x=148;src.y=34;}
    // 
    if(val==-23) {src.x=100;src.y=84;}
    // 
    if(val==-22) {src.x=116;src.y=84;}
    // 
    if(val==-24) {src.x=132;src.y=84;}
    // 
    if(val==-21) {src.x=132;src.y=151;}
    // 
    if(val==-32) {src.x=148;src.y=84;}
    // 
    if(val==-30) {src.x=148;src.y=103;}
    // 
    if(val==-28) {src.x=148;src.y=135;}
    // 
    if(val==-18) {src.x=84;src.y=119;}
    // 
    if(val==-17) {src.x=116;src.y=151;}
    // 
    if(val==-5) {src.x=84;src.y=103;}
    // 
    if(val==-7) {src.x=148;src.y=151;}
    // 
    if(val==-4) {src.x=116;src.y=135;}
    // 
    if(val==-10) {src.x=132;src.y=135;}
    // 
    if(val==-12) {src.x=148;src.y=119;}
            
    //ponctuation
    // -
    if(val==45) {src.x=102;src.y=34;}
    // .
    if(val==46) {src.x=118;src.y=34;}
    // ,
    if(val==44) {src.x=134;src.y=34;}
    // !
    if(val==33) {src.x=3;src.y=135;}
    // ?
    if(val==63) {src.x=19;src.y=135;}
    // (
    if(val==40) {src.x=35;src.y=135;}
    // )
    if(val==41) {src.x=51;src.y=135;}            
    // ' ( avec @ )
    if(val==39) {src.x=67;src.y=135;}
    // :
    if(val==58) {src.x=83;src.y=135;}
    // ... ( avec % )
    if(val==37) {src.x=101;src.y=135;}
    // >
    if(val==62) {src.x=100;src.y=151;}
    // <
    if(val==60) {src.x=84;src.y=151;}
            
    //chiffres            
    if(val>=48 && val<=57) {src.x=3+16*((val-48)%5); src.y=103+16*((val-48)/5);}
    
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
}

bool Texte::hasNext() {
    return (buffer != "" || idsuiv > 0);
}

bool Texte::suite() {
    if (av < (int)texte.length()) {
        av = texte.length();
        return true;
    }
    if (!hasNext()) {
        gpJeu->getAudio()->playSound(18);
        return gpJeu->finTexte(id);
    }
    if (buffer != "") {
        texte = buffer;
        buffer = "";
    }
    else {
        id = idsuiv;
        idsuiv = 0;
        chercheText();
    }
    decoupeText();
    if (def) av = 0;
    else av = texte.length();
    gpJeu->getAudio()->playSound(17);
    return true;
}
